package com.winhc.bigdata.spark.jobs

import com.winhc.bigdata.spark.config.EsConfig
import com.winhc.bigdata.spark.utils.CompanyEsUtils.getEsDoc
import com.winhc.bigdata.spark.utils.SparkUtils

/**
 * @Author: XuJiakai
 * @Date: 2020/6/5 14:28
 * @Description:
 */
object CompanyIndexSave2Es {
  private def getOtherIdName(str: String): scala.collection.Map[String, String] = {
    if (str == null) {
      return null
    }
    str.split("\002").map(s => {
      val sp = s.split("\001")
      (sp(0), sp(1))
    }).toMap
  }

  def main(args: Array[String]): Unit = {
    val map = EsConfig.getEsConfigMap

    val company_name_mapping = "winhc_eci_dev.company_name_mapping_pro_v2"

    val spark = SparkUtils.InitEnv("CompanyIndexSave2Es", map)
    val df = spark.sql(s"select cid,cname,other_id_name,new_cid,company_type from $company_name_mapping")
    import org.elasticsearch.spark._
    import spark.implicits._
    df.map(r => {
      val cid = r.getLong(0).toString
      val cname = r.getString(1)
      val other_id_name = getOtherIdName(r.getString(2))
      val new_cid = r.getString(3)
      val company_type = r.getString(4)
      getEsDoc(cid, cname, other_id_name, new_cid, company_type)
    }).rdd.saveToEsWithMeta("winhc-company-v2/company")
    spark.stop()
  }
}
